diff --git a/MagickWand/mogrify.c b/MagickWand/mogrify.c
index 65658eb307..da235741b7 100644
--- a/MagickWand/mogrify.c
+++ b/MagickWand/mogrify.c
@@ -1087,8 +1087,12 @@ WandExport MagickBooleanType MogrifyImage(ImageInfo *image_info,const int argc,
             */
             (void) SyncImageSettings(mogrify_info,*image,exception);
             flags=ParseGeometry(argv[i+1],&geometry_info);
+            if ((flags & XiValue) == 0)
+              geometry_info.xi=128.0;
             if ((flags & PercentValue) != 0)
-              geometry_info.psi=(double) 65536.0*geometry_info.psi/100.0;
+              geometry_info.psi=(double) ((PerceptibleReciprocal(
+                geometry_info.xi)*(geometry_info.rho*geometry_info.sigma))*
+                (1.0+65535.0*geometry_info.psi/100.0));
             (void) CLAHEImage(*image,(size_t) geometry_info.rho,(size_t)
               geometry_info.sigma,(size_t) geometry_info.xi,(double)
               geometry_info.psi,exception);
diff --git a/MagickWand/operation.c b/MagickWand/operation.c
index 17185bfe4f..af33f5b80a 100644
--- a/MagickWand/operation.c
+++ b/MagickWand/operation.c
@@ -1971,8 +1971,12 @@ static MagickBooleanType CLISimpleOperatorImage(MagickCLI *cli_wand,
           flags=ParseGeometry(arg1,&geometry_info);
           if ((flags & (RhoValue|SigmaValue)) == 0)
             CLIWandExceptArgBreak(OptionError,"InvalidArgument",option,arg1);
-          if ((flags & PercentValue) != 0)
-            geometry_info.psi=(double) 65536.0*geometry_info.psi/100.0;
+           if ((flags & XiValue) == 0)
+             geometry_info.xi=128.0;
+           if ((flags & PercentValue) != 0)
+             geometry_info.psi=(double) ((PerceptibleReciprocal(
+               geometry_info.xi)*(geometry_info.rho*geometry_info.sigma))*
+               (1.0+65535.0*geometry_info.psi/100.0));
           (void) CLAHEImage(_image,(size_t) geometry_info.rho,(size_t)
             geometry_info.sigma,geometry_info.xi,geometry_info.psi,_exception);
           break;
diff --git a/PerlMagick/Magick.xs b/PerlMagick/Magick.xs
index a10788f23c..cbeeb9fc51 100644
--- a/PerlMagick/Magick.xs
+++ b/PerlMagick/Magick.xs
@@ -11482,8 +11482,12 @@ Mogrify(ref,...)
             {
               flags=ParseGeometry(argument_list[0].string_reference,
                 &geometry_info);
+              if ((flags & XiValue) == 0)
+                geometry_info.xi=128.0;
               if ((flags & PercentValue) != 0)
-                geometry_info.xi=QuantumRange*geometry_info.xi/100.0;
+                geometry_info.psi=(double) ((PerceptibleReciprocal(
+                  geometry_info.xi)*(geometry_info.rho*geometry_info.sigma))*
+                  (1.0+65535.0*geometry_info.psi/100.0));
             }
           if (attribute_flag[1] != 0)
             geometry_info.rho=argument_list[1].integer_reference;
diff --git a/PerlMagick/quantum/quantum.xs.in b/PerlMagick/quantum/quantum.xs.in
index 322fad4382..cd8b8782c9 100644
--- a/PerlMagick/quantum/quantum.xs.in
+++ b/PerlMagick/quantum/quantum.xs.in
@@ -11488,8 +11488,12 @@ Mogrify(ref,...)
             {
               flags=ParseGeometry(argument_list[0].string_reference,
                 &geometry_info);
+              if ((flags & XiValue) == 0)
+                geometry_info.xi=128.0;
               if ((flags & PercentValue) != 0)
-                geometry_info.xi=QuantumRange*geometry_info.xi/100.0;
+                geometry_info.psi=(double) ((PerceptibleReciprocal(
+                  geometry_info.xi)*(geometry_info.rho*geometry_info.sigma))*
+                  (1.0+65535.0*geometry_info.psi/100.0));
             }
           if (attribute_flag[1] != 0)
             geometry_info.rho=argument_list[1].integer_reference;
